## magics++ 4.12.1

=== CMakeLists.txt ===
############################################################################################
# cmake options:
#
#       -DCMAKE_BUILD_TYPE=Debug|RelWithDebInfo|Release|Production
#
#       -DCMAKE_MODULE_PATH=/path/to/ecbuild/cmake
#
#       -DCMAKE_C_COMPILER=gcc
#
#       -DCMAKE_PREFIX_PATH=/path/to/jasper:/path/to/any/package/out/of/place
#

cmake_minimum_required( VERSION 3.12 FATAL_ERROR )

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")
find_package( ecbuild 3.4 REQUIRED )

project( magics VERSION 4.12.1 LANGUAGES CXX )

# make sure that the header files are installed into include/magics
# note that this needs to be done before ecbuild_declare_project()
# to ensure that the ecbuild header files are also put there
# note also that we need to CACHE this so that ecbuild_declare_project() does not overwrite it
set(INSTALL_INCLUDE_DIR include/magics CACHE PATH "Magics installation directory for header files")

include(ecbuild_system NO_POLICY_SCOPE)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_C_STANDARD 99)

###############################################################################
# some build options for this project


ecbuild_add_option( FEATURE CAIRO
                    DEFAULT ON
                    DESCRIPTION "cairo support[png/jpeg]"
                    REQUIRED_PACKAGES PangoCairo)

ecbuild_add_option( FEATURE DOCUMENTATION
                    DEFAULT OFF
                    DESCRIPTION "Adding support for automatic documentation"
                  )


string(STRIP "${PANGOCAIRO_LIBRARIES}" PANGOCAIRO_LIBRARIES)
if(PANGOCAIRO_FOUND)
 set(HAVE_CAIRO ON)
  ecbuild_enable_feature( CAIRO )
endif()

ecbuild_add_option( FEATURE GEOTIFF
                    DEFAULT OFF
                    DESCRIPTION "geotiff support [implies cairo] -  work on progress"
                    CONDITION HAVE_CAIRO
                    REQUIRED_PACKAGES GeoTIFF )

ecbuild_add_option( FEATURE NETCDF
                    DEFAULT ON
                    DESCRIPTION "enable netcdf support"
                    REQUIRED_PACKAGES "NetCDF 4 COMPONENTS C" )


ecbuild_add_option( FEATURE ODB
                    DEFAULT OFF
                    DESCRIPTION "ODB support - to be deprecated"
                    REQUIRED_PACKAGES "odc" )

ecbuild_add_option( FEATURE METVIEW
                    DEFAULT OFF
                    DESCRIPTION "enable Metview interface" )

ecbuild_add_option( FEATURE METVIEW_NO_QT
                    DEFAULT OFF
                    DESCRIPTION "enable Metview interface without Qt" )

ecbuild_add_option( FEATURE EFAS
                    DEFAULT OFF
                    DESCRIPTION "enable EFAS coastlines and catchments" )


set( MAGICS_NAME          "Magics" )
set( MAGICS_INSTALL_PATH  ${CMAKE_INSTALL_PREFIX} )


###############################################################################
### Metview and Qt
ecbuild_info("TESTING for Metview and Qt ...")

if(HAVE_METVIEW AND HAVE_METVIEW_NO_QT)
    ecbuild_critical("Do not set both HAVE_METVIEW and HAVE_METVIEW_NO_QT - only set one. You may have to remove your CMakeCache.txt to clear these settings.")
endif()

set( qt no )
set( metview no )

if( HAVE_METVIEW_NO_QT )
	set( metview yes )
	unset(MAGICS_ONLY)
endif()

if( HAVE_METVIEW )
    set ( metview yes)
    ecbuild_info("TESTING for Qt6 ...")
    unset(MAGICS_ONLY)

    find_package(Qt6Widgets)
    if( Qt6Widgets_FOUND )
        ecbuild_info("Qt6 was found ... ${Qt6Widgets_VERSION_STRING}")
        include_directories(${Qt6Widgets_INCLUDE_DIRS})
        set( MAGICS_QT 1)
        set( MAGICS_QT6 1)
        set( qt yes)
    else()
        find_package(Qt5Widgets REQUIRED)
        if( Qt5Widgets_FOUND )
            ecbuild_info("Qt5 was found ... ${Qt5Widgets_VERSION_STRING}")
            include_directories(${Qt5Widgets_INCLUDE_DIRS})
            set( MAGICS_QT 1)
            set( MAGICS_QT5 1)
            set( qt yes)
        else()
            ecbuild_critical("Neither Qt5 nor Qt6 were found ...")
        endif()
    endif()
endif()

ecbuild_declare_project()

###############################################################################
# find extra packages

ecbuild_find_package( NAME eccodes VERSION 2.24.0 REQUIRED
                      FAILURE_MSG "ecCodes is required in order to build Magics" )
set( HAVE_GRIB 1 )
set( HAVE_BUFR 1 )




# adding NO_MODULE means that if we don't find it, CMake will not generate
# strange error messages about not being able to find the FindProj4.cmake file.
# this should find proj if it has been installed via CMake, but if it has been
# installed via autotools, then we will need to try another method
#ecbuild_find_package(NAME PROJ4 VERSION 6.1.0 QUIET )

# find_package( PROJ4 6.1.0 NO_MODULE )
# if(NOT PROJ4_FOUND)
find_package(PROJ 6.1.0 REQUIRED)
if (NOT PROJ_FOUND)
    message(FATAL_ERROR "Package 'proj' was not found - at least version 6.1.0 required.")
endif()

message("PROJ include: ${PROJ_INCLUDE_DIR}")
message("PROJ library: ${PROJ_LIBRARIES}")
list( APPEND MAGICS_PRIVATE_INCLUDE_DIRS ${PROJ_INCLUDE_DIR})
# endif()


find_package( EXPAT REQUIRED )   # for MagML

if(APPLE)
  find_package( zlib REQUIRED )  # dependency of minizip - KMZ support
endif(APPLE)

### check support for DL library
#
#  code taken from eckit (src/eckit/CMakeList.txt)
#
if( NOT EC_OS_NAME MATCHES "windows" )
check_include_files( dlfcn.h magics_HAVE_DLFCN_H )

if(NOT magics_HAVE_DLFCN_H)
message(FATAL_ERROR "Magics requires dlfcn.h for supporting the detection of the shared folder")
endif()

cmake_push_check_state(RESET)
    set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_DL_LIBS} )
    check_c_source_compiles( "#define _GNU_SOURCE\n#include <dlfcn.h>\nint main(){ void* addr; Dl_info info; dladdr(addr, &info); }\n"
        magics_HAVE_DLADDR )
cmake_pop_check_state()

endif()

###############################################################################
# Windows compiler options

if( EC_OS_NAME MATCHES "windows" )
    # Suppress compliler warnings
    # Suppress warnings about using 'insecure' functions. Fixing this would require changes all over
    # the codebase which would damage portability.
    ecbuild_add_c_flags("/D_CRT_SECURE_NO_WARNINGS")
    ecbuild_add_cxx_flags("/D_CRT_SECURE_NO_WARNINGS")
    # Suppress warnings about using well-known C functions.
    ecbuild_add_c_flags("/D_CRT_NONSTDC_NO_DEPRECATE")
    ecbuild_add_cxx_flags("/D_CRT_NONSTDC_NO_DEPRECATE")
    # For M_PI
    ecbuild_add_c_flags("/D_USE_MATH_DEFINES")
    ecbuild_add_cxx_flags("/D_USE_MATH_DEFINES")
    # Suppress C4267: warns about possible loss of data when converting 'size_t' to 'int'.
    ecbuild_add_c_flags("/wd4267")
    ecbuild_add_cxx_flags("/wd4267")
    # Suppress C4800: forcing value to bool 'true' or 'false'
    ecbuild_add_cxx_flags("/wd4800")
    # Suppress C4244: convertions from double to int
    #ecbuild_add_cxx_flags("/wd4244")
    # Suppress C4244: convertions from double to float
    #ecbuild_add_cxx_flags("/wd4305")

#### /D PROJ_MSVC_DLL_IMPORT

    # Prevent fatal error C1128
    ecbuild_add_cxx_flags("/bigobj")

else()

  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wno-unused-parameter -Wno-overloaded-virtual -Wno-unused-variable -Wno-reorder -Wno-sign-compare")

  # set(CMAKE_CXX_FLAGS "-Wall -Wextra -Wno-unused-parameter -Wno-overloaded-virtual -Wno-unused-variable -Wno-reorder-ctor -Wno-sign-compare")

endif()

###############################################################################
# contents

if ( HAVE_ODB )
  ecbuild_info("Adding support for ODB")
  list( APPEND MAGICS_EXTRA_LIBRARIES odccore)
endif()



if( HAVE_CAIRO )
  list( APPEND MAGICS_PRIVATE_INCLUDE_DIRS ${PANGOCAIRO_INCLUDE_DIRS})

  if( EC_OS_NAME MATCHES "windows" )


    # Looks like the transitivity of includes is broken
    find_package(PkgConfig REQUIRED)

    pkg_search_module(GLIB REQUIRED glib-2.0)
    list( APPEND MAGICS_PRIVATE_INCLUDE_DIRS ${GLIB_INCLUDE_DIRS})

    pkg_search_module(CAIRO REQUIRED cairo)
    list( APPEND MAGICS_PRIVATE_INCLUDE_DIRS ${CAIRO_INCLUDE_DIRS})

    pkg_search_module(HARFBUZZ REQUIRED harfbuzz)
    list( APPEND MAGICS_PRIVATE_INCLUDE_DIRS ${HARFBUZZ_INCLUDE_DIRS})

  endif()

endif()

set( MAGICS_LIBRARIES MagPlus )

if( MAGICS_QT )
    if( MAGICS_QT6 )
        list( APPEND MAGICS_EXTRA_INCLUDE_DIRS  ${Qt6Widgets_INCLUDE_DIR} )
        list( APPEND MAGICS_EXTRA_LIBRARIES     ${Qt6Widgets_LIBRARIES})
    elseif ( MAGICS_QT5 )
        list( APPEND MAGICS_EXTRA_INCLUDE_DIRS  ${Qt5Widgets_INCLUDE_DIR} )
        list( APPEND MAGICS_EXTRA_LIBRARIES     ${Qt5Widgets_LIBRARIES})
    endif()
    if( WITH_QT_DEBUG )
        list( APPEND MAGICS_EXTRA_DEFINITIONS QT_NO_DEBUG_OUTPUT )
    endif()
endif()

if( HAVE_GEOTIFF )
	list( APPEND MAGICS_EXTRA_INCLUDE_DIRS	${GEOTIFF_INCLUDE_DIR} )
	list( APPEND MAGICS_EXTRA_LIBRARIES	${GEOTIFF_LIBRARY} )
	list( APPEND MAGICS_EXTRA_DEFINITIONS	HAVE_GEOTIFF )
endif()

list( APPEND MAGICS_EXTRA_LIBRARIES     ${CMAKE_THREAD_LIBS_INIT} )

if( EC_OS_NAME MATCHES "windows" )
    # We need to link to ws2_32.lib to avoid an unresolved external (gethostname)
    # It's part of the Windows SDK so no need to search for it.
    list( APPEND MAGICS_EXTRA_LIBRARIES ws2_32 )
    # We need to find zlib.lib
    # find_library( ZLIB_LIB zlib PATHS ENV PATH )
    # list( APPEND MAGICS_EXTRA_LIBRARIES ${ZLIB_LIB} )
    find_package( ZLIB REQUIRED )   # for MagML
    message("ZLIB include: ${ZLIB_INCLUDE_DIR}")
    message("ZLIB library: ${ZLIB_LIBRARIES}")
    list( APPEND MAGICS_EXTRA_LIBRARIES ${ZLIB_LIBRARIES} )
endif()

ecbuild_debug("MAGICS_EXTRA_DEFINITIONS  => ${MAGICS_EXTRA_DEFINITIONS}")
ecbuild_debug("MAGICS_EXTRA_INCLUDE_DIRS => ${MAGICS_EXTRA_INCLUDE_DIRS}")
ecbuild_debug("MAGICS_EXTRA_LIBRARIES    => ${MAGICS_EXTRA_LIBRARIES}")

get_directory_property( MAGICS_DEFINITIONS COMPILE_DEFINITIONS )

add_subdirectory( tools )
add_subdirectory( src )
add_subdirectory( share )
add_subdirectory( apps )
add_subdirectory( test )
if( HAVE_DOCUMENTATION )
  add_subdirectory( docs )
endif()


if(NOT HAVE_EFAS)
  ecbuild_add_resources( TARGET noefas DONT_PACK_DIRS share/magics/efas)
endif()

# Directories not need in the distribution tar ball!
ecbuild_add_resources( TARGET bamboo DONT_PACK_DIRS bamboo)
ecbuild_add_resources( TARGET old_resources
		DONT_PACK_DIRS
		docs
		regression
		toolsjs
		notebook)



############################################################################################
# finalize

set( MAGICS_DESCRIPTION "Multi-platform meteorological graphics library" )
set( MAGICS_URL "https://software.ecmwf.int/magics" )

### print all variables
#get_cmake_property(_variableNames VARIABLES)
#foreach (_variableName ${_variableNames})
#    ecbuild_info("${_variableName}=${${_variableName}}")
#endforeach()

ecbuild_install_project( NAME Magics )

ecbuild_print_summary()

=== debian/changelog ===
magics++ (4.12.1-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.6.1

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 26 May 2022 10:41:13 +0100

magics++ (4.12.0-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 19 May 2022 10:39:17 +0100

magics++ (4.11.0-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 08 Mar 2022 08:58:29 +0000

=== debian/control ===
Source: magics++
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat  (= 13) , 
 ecbuild (>= 3.3.0-3),
 gfortran | fortran-compiler, 
 python3-all-dev,
 libhdf5-dev | libhdf5-mpi-dev, 
 libnetcdf-dev, libnetcdf-cxx-legacy-dev,
 libgl1-mesa-dev, libgd-dev, 
 libemos-dev (>=  2:4.3.9), libgeotiff-dev,
 libeccodes-dev (>= 2.13.0-3),
 libeccodes-tools,
 libodc-dev [!powerpc !armel !armhf !i386 !mipsel],
 odc [!powerpc !armel !armhf !i386 !mipsel],
 libemos-bin, 
 libopenjp2-7-dev,
 libaec-dev,
 libterralib-dev, 
 libcairo2-dev, 
 libpango1.0-dev,
 fonts-dejavu-core, 
 libxml-parser-perl, 
 ghostscript, 
 zlib1g-dev, 
 libboost-dev | libboost1.74-dev, 
 libproj-dev, 
 qtbase5-dev-tools, 
 qtbase5-dev, 
 qt5-qmake,
 python3-jinja2
Standards-Version: 4.6.1
Homepage: https://software.ecmwf.int/wiki/display/MAGP/Magics
Vcs-Browser: https://salsa.debian.org/science-team/magics.git
Vcs-Git: https://salsa.debian.org/science-team/magics.git -b debian/latest

Package: libmagplus3v5
Section: libs
Architecture: any
Multi-Arch: same
Depends: libmagics++-data,${misc:Depends}, ${shlibs:Depends}, fonts-dejavu-core, fonts-dejavu-extra, ghostscript
Description: ECMWF meteorological plotting software library
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 Besides its programming interfaces (Fortran and C), Magics++ offers MagML,
 a plot description language based on XML aimed at automatic web production.
 .
 The library supports the plotting of contours, wind fields, observations,
 satellite images, symbols, text, axis and graphs (including boxplots).
 .
 Data fields to be plotted may be presented in various formats,
 for instance GRIB 1 and 2 code data, Gaussian grid, regularly spaced grid
 and fitted data. Input data can also be in BUFR and NetCDF format
 or retrieved from an ODB database.
 .
 The produced meteorological plots can be saved in various formats,
 such as PostScript, EPS, PDF, GIF, PNG, SVG and KML.

Package: libmagics++-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libmagplus3v5 ( = ${binary:Version} ), 
 ${misc:Depends}, ${ecbuild:Depends},
 python3, libmagics++-metview-dev, libterralib-dev, magics++,
 libodc-dev [!powerpc !armel !armhf !i386 !mipsel]
Recommends: pkg-config
Description: Development files for ECMWF  plotting software MAGICS++
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 Besides its programming interfaces (Fortran and C), Magics++ offers MagML,
 a plot description language based on XML aimed at automatic web production.
 .
 This package includes the header files and static libraries needed to build 
 against libmagics++.

Package: magics++
Architecture: any
Multi-Arch: foreign
Depends: libmagplus3v5 ( = ${binary:Version} ),
 ${perl:Depends}, ${misc:Depends}, ${shlibs:Depends}, python3
Description: Executables for the magics++ library
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 Besides its programming interfaces (Fortran and C), Magics++ offers MagML,
 a plot description language based on XML aimed at automatic web production.
 .
 This package contains the MagcML binary that may be used with magics++.


Package: libmagics++-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Data files needed for magics++ library
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 .
 This package contains data expected by the magics++ library.


Package: libmagics++-metview-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libmagplus3v5 ( = ${binary:Version} )
Description: Libraries needed for building MetView
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 .
 This package includes the header files and static libraries needed to build
 metview against magics++.

## magics++ 4.13.0~pre1

=== debian/changelog ===
magics++ (4.13.0~pre1-2) unstable; urgency=medium

  * Relax dep on odc for hppa. Thanks to John David Anglin.
    Closes: #1021453

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 10 Oct 2022 06:03:34 +0100

magics++ (4.13.0~pre1-1) experimental; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 05 Sep 2022 12:38:02 +0100

magics++ (4.12.1-2) unstable; urgency=medium

  * Build against Qt6 instead of Qt5

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 01 Sep 2022 08:38:07 +0100

## magics++ 4.13.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")
 find_package( ecbuild 3.4 REQUIRED )
 
-project( magics VERSION 4.12.1 LANGUAGES CXX )
+project( magics VERSION 4.13.0 LANGUAGES CXX )
 
 # make sure that the header files are installed into include/magics
 # note that this needs to be done before ecbuild_declare_project()

=== apps/metgram/CMakeLists.txt ===
# Copy metgram executable to the build tree
configure_file( metgram  metgram COPYONLY )
configure_file( metgram-script.in  metgram.sh @ONLY )

# Set metgram script path for use by dependencies in a bundle
set( MAGICS_METEOGRAM_SCRIPT ${CMAKE_CURRENT_SOURCE_DIR}/metgram
     CACHE FILEPATH "Path to metgram script" )

install( DIRECTORY templates/ DESTINATION ${INSTALL_DATA_DIR}
         FILE_PERMISSIONS OWNER_READ GROUP_READ WORLD_READ )

install ( FILES ${CMAKE_CURRENT_SOURCE_DIR}/metgram  ${CMAKE_CURRENT_BINARY_DIR}/metgram.sh 
          DESTINATION ${INSTALL_BIN_DIR}
          PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
          OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE)

ecbuild_add_executable( TARGET        metgramx
                        SOURCES       metgramx.cc
                        DEFINITIONS   ${MAGICS_EXTRA_DEFINITIONS}
                        LIBS          MagPlus ${PROJ_LIBRARIES} ${MAGICS_EXTRA_LIBRARIES}
    )

=== regression/venice/CMakeLists.txt ===
# magics test executable run in script

add_magics_test(NAME venice_test01 SOURCES test01.f IMAGE test01.ps THRESHOLD 2)
add_magics_test(NAME venice_test02 SOURCES test02.f RESOURCES input_test02 IMAGE test02.ps DATA TOWER.ope_2010 WAS_RES.2010 THRESHOLD 1.5)
add_magics_test(NAME venice_test03 SOURCES test03.f RESOURCES fort.11 fort.12 fort.13 fort.14 fort.15 input03 IMAGE test03.ps DATA TOWER.ope_2010 WAS_RES.2010 THRESHOLD 1.8)
add_magics_test(NAME venice_test05 SOURCES test05.f RESOURCES fort.51 IMAGE test05.ps THRESHOLD 2)
add_magics_test(NAME venice_test06 SOURCES test06.f RESOURCES fort.61 IMAGE test06.ps THRESHOLD 1)
add_magics_test(NAME venice_test08 SOURCES test08.f RESOURCES fort.82 fort.83 Logo_Ismar.png Logo_ICPSM.png IMAGE test08.ps THRESHOLD 1)
add_magics_test(NAME venice_multilines SOURCES multilines.f IMAGE BOX_ON_MAP.ps THRESHOLD 1)

=== debian/changelog ===
magics++ (4.13.0-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 23 Nov 2022 15:01:57 +0000

=== debian/control ===
--- 
+++ 
@@ -12,8 +12,8 @@
  libemos-dev (>=  2:4.3.9), libgeotiff-dev,
  libeccodes-dev (>= 2.13.0-3),
  libeccodes-tools,
- libodc-dev [!powerpc !armel !armhf !i386 !mipsel],
- odc [!powerpc !armel !armhf !i386 !mipsel],
+ libodc-dev [!powerpc !armel !armhf !hppa !i386 !mipsel],
+ odc [!powerpc !armel !armhf !hppa !i386 !mipsel],
  libemos-bin, 
  libopenjp2-7-dev,
  libaec-dev,
@@ -26,9 +26,9 @@
  zlib1g-dev, 
  libboost-dev | libboost1.74-dev, 
  libproj-dev, 
- qtbase5-dev-tools, 
- qtbase5-dev, 
- qt5-qmake,
+ qt6-base-dev,
+ libqt6core5compat6-dev,
+ libqt6svg6-dev,
  python3-jinja2
 Standards-Version: 4.6.1
 Homepage: https://software.ecmwf.int/wiki/display/MAGP/Magics
@@ -65,7 +65,7 @@
 Depends: libmagplus3v5 ( = ${binary:Version} ), 
  ${misc:Depends}, ${ecbuild:Depends},
  python3, libmagics++-metview-dev, libterralib-dev, magics++,
- libodc-dev [!powerpc !armel !armhf !i386 !mipsel]
+ libodc-dev [!powerpc !armel !armhf !hppa !i386 !mipsel]
 Recommends: pkg-config
 Description: Development files for ECMWF  plotting software MAGICS++
  Magics++ is the latest generation of the ECMWF's Meteorological plotting

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# To enable all, uncomment following line
# DEB_BUILD_MAINT_OPTIONS:= hardening=+all,-pie
CXXFLAGS:= -fPIC $(shell dpkg-buildflags --get CXXFLAGS) # -std=c++14
# CFLAGS:= -fPIC $(shell dpkg-buildflags --get CFLAGS) 
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Set for build reproducibility
LC_ALL=C
export LC_ALL

LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
CMAKEDIR:=debian/tmp/$(LIBDIR)/cmake/magics

# Fixes for 32-bit archss
ARCH_32BIT:=   i386 armel armhf mipsel hppa hurd-i386 m68k powerpc sh4 x32
DO_ODB:= $(if $(filter $(DEB_TARGET_ARCH), $(ARCH_32BIT)),OFF,ON)

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

%:
	dh $@ --with-buildsystem=ecbuild

export extra_flags +=  \
	-DBUILD_SITE=debian \
	-DENABLE_LIBGD=1 \
	-DHAVE_BOOST=1 \
	-DENABLE_ODB=$(DO_ODB) \
	-DENABLE_EFAS=1 \
	-DHAVE_DLFCN_H=1 \
	-DHAVE_INTTYPES_H=1 \
	-DHAVE_LIBEXPAT=1 \
	-DHAVE_LIBPROJ=1 \
	-DHAVE_LIBPTHREAD=1 \
	-DHAVE_LIBZ=1 \
	-DHAVE_MEMORY_H=1 \
	-DHAVE_STDINT_H=1 \
	-DHAVE_STDLIB_H=1 \
	-DHAVE_STRINGS_H=1 \
	-DHAVE_STRING_H=1 \
	-DHAVE_SYS_STAT_H=1 \
	-DHAVE_STS_TYPES_H=1 \
	-DHAVE_UNISTD_H=1 \
	-DMAGICS_ALLHEADERS=1 \
	-DMAGICS_GRIB=1 \
	-DMAGICS_JSON=1 \
	-DMAGICS_GIF=1 \
	-DMAGICS_GIF_ANIMATED=1 \
	-DMAGICS_TIFF=1 \
	-DMAGICS_TTF=1 \
	-DMAGICS_TTF_PATH="share/magics/ttf/" \
	-DMAGICS_SITE="debian" \
	-DMAGICS_THREADS=1 \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DBUILD_DOCUMENTATION=ON \
	-DENABLE_FORTRAN=ON \
	-DENABLE_LARGE_FILE_SUPPORT=ON \
	-DBUILD_EXAMPLES=ON \
	-DBUILD_SHARED_LIBS=ON \
	-DENABLE_TESTS=ON \
	-DENABLE_GEOTIFF=ON \
	-DGEOTIFF_INCLUDE_DIR=/usr/include/geotiff \
	-DENABLE_RPATHS=OFF \
	-DENABLE_CAIRO=ON \
	-DENABLE_BUFR=ON \
	-DENABLE_GRIB=ON \
	-DENABLE_METVIEW=ON \
	-DENABLE_NETCDF=ON \
	-DCMAKE_C_FLAGS='$(CFLAGS) ' \
	-DCMAKE_CXX_FLAGS='$(CXXFLAGS) -I/usr/include/terralib -I/usr/include/terralib/kernel -I/usr/include/geotiff' \
	-DMAGICS_EXTRA_LIBRARIES='-lterralib -lgd -lemosR64' 

export LD_LIBRARY_PATH:=$(CURDIR)/debian/tmp/usr/lib:$(LD_LIBRARY_PATH)

override_dh_auto_clean:
	# remove Makefile: it attempts a Docker build from git ...
	rm -f Makefile
	rm -rf debian/build-py* build/*x
	rm -f bin/magjsonx  bin/magmlx  bin/metgramx
	find . -type l -delete
	find . -name '.DS_Store' -delete
	rm -f src/params/*.h src/decoders/*Attributes.h
	rm -rf share/magics/ttf src/terralib debian/build src/boost

override_dh_auto_configure:
	dh_auto_configure -- $(extra_flags)
	# link for font for tesing.
	mkdir -p share/fonts/truetype/ttf-dejavu/
	ln -sf /usr/share/fonts/truetype/ttf-dejavu/DejaVuSans.ttf share/fonts/truetype/ttf-dejavu/
	# Link terralib
	[ -e src/terralib ] || ln -sf  /usr/include/terralib src/terralib

override_dh_auto_test check:
	# echo "Tests disabled; see README-testfailures.txt for details"
	#(ulimit -s 8192; export PYTHONPATH=$(CURDIR)/debian/build-py3/python/Magics ; \
	#	export MAGPLUS_HOME=$(CURDIR) ; $(MAKE) -C debian/build-py3  check )

override_dh_auto_install:
	dh_auto_install 
	# sed -i -e 's%$${_IMPORT_PREFIX}/${LIBDIR}%${LIBDIR}%g' $(CMAKEDIR)/magics-targets-none.cmake
	#sed -i -e 's%$${_IMPORT_PREFIX}/bin%/usr/bin%g'  $(CMAKEDIR)/magics-targets-none.cmake
	sed -i -e 's%${CURDIR}%/build/magics++%g'       $(CMAKEDIR)/magics-config.cmake 
	sed -i -e 's%${CURDIR}%/build/magics++%g'       $(CMAKEDIR)/magics-import.cmake 
	#sed -i -e 's%$${_IMPORT_PREFIX}/include/magics%/usr/include/magics%g' $(CMAKEDIR)/magics-targets.cmake
	sed -i -e 's%$${CURDIR}%/build/magics++%g' $(CMAKEDIR)/magics-import.cmake 
	-find debian/tmp/usr/bin -type f  -exec chrpath -d {} \;
	-find debian/tmp debian/libmagplus3v5   -name '*.so*' -exec chrpath -d {} \;

override_dh_makeshlibs:
	# For new symbols when compiled with GCC 7
	dh_makeshlibs -V'libmagplus3v5 (>= 2.34.1-2~)'

## magics++ 4.14.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,10 @@
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")
 find_package( ecbuild 3.4 REQUIRED )
 
-project( magics VERSION 4.13.0 LANGUAGES CXX )
+
+# In prepaation for hotfix of 4.14.0
+project( magics LANGUAGES CXX )
+
 
 # make sure that the header files are installed into include/magics
 # note that this needs to be done before ecbuild_declare_project()

=== debian/changelog ===
magics++ (4.14.1-1) unstable; urgency=medium

  * New upstream release
  * Change obsolete build-deps: libgl1-mesa-dev -> libgl-dev

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 15 Jul 2023 07:38:24 +0100

magics++ (4.13.0-2) unstable; urgency=medium

  * Drop libnetcdf-c++-legacy-dev . Closes: #1038449
  * Standards-Version: 4.6.2

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 19 Jun 2023 11:48:18 +0100

=== debian/control ===
--- 
+++ 
@@ -7,8 +7,8 @@
  gfortran | fortran-compiler, 
  python3-all-dev,
  libhdf5-dev | libhdf5-mpi-dev, 
- libnetcdf-dev, libnetcdf-cxx-legacy-dev,
- libgl1-mesa-dev, libgd-dev, 
+ libnetcdf-dev, libnetcdf-c++4-dev,
+ libgl-dev, libgd-dev, 
  libemos-dev (>=  2:4.3.9), libgeotiff-dev,
  libeccodes-dev (>= 2.13.0-3),
  libeccodes-tools,
@@ -30,7 +30,7 @@
  libqt6core5compat6-dev,
  libqt6svg6-dev,
  python3-jinja2
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://software.ecmwf.int/wiki/display/MAGP/Magics
 Vcs-Browser: https://salsa.debian.org/science-team/magics.git
 Vcs-Git: https://salsa.debian.org/science-team/magics.git -b debian/latest

## magics++ 4.14.2

=== debian/changelog ===
magics++ (4.14.2-2) unstable; urgency=medium

  * Drop libproj-dev & libnetcdf-c++4-dev build-deps. Unused
    Closes: #1050776
  * Add XKB build-dep 

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 29 Aug 2023 09:49:11 +0100

magics++ (4.14.2-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 08 Aug 2023 11:35:39 +0100

=== debian/control ===
--- 
+++ 
@@ -6,10 +6,12 @@
  ecbuild (>= 3.3.0-3),
  gfortran | fortran-compiler, 
  python3-all-dev,
+ libxcb-xkb-dev,
  libhdf5-dev | libhdf5-mpi-dev, 
- libnetcdf-dev, libnetcdf-c++4-dev,
+ libnetcdf-dev,
+ libgeotiff-dev,
  libgl-dev, libgd-dev, 
- libemos-dev (>=  2:4.3.9), libgeotiff-dev,
+ libemos-dev (>=  2:4.3.9),
  libeccodes-dev (>= 2.13.0-3),
  libeccodes-tools,
  libodc-dev [!powerpc !armel !armhf !hppa !i386 !mipsel],
@@ -25,7 +27,6 @@
  ghostscript, 
  zlib1g-dev, 
  libboost-dev | libboost1.74-dev, 
- libproj-dev, 
  qt6-base-dev,
  libqt6core5compat6-dev,
  libqt6svg6-dev,

## magics++ 4.15.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,10 +15,7 @@
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")
 find_package( ecbuild 3.4 REQUIRED )
 
-
-# In prepaation for hotfix of 4.14.0
-project( magics LANGUAGES CXX )
-
+project( magics VERSION 4.15.0 LANGUAGES CXX )
 
 # make sure that the header files are installed into include/magics
 # note that this needs to be done before ecbuild_declare_project()

=== debian/changelog ===
magics++ (4.15.0-1) unstable; urgency=medium

  * New upstream release
  * Explicitly B-D on architecture-is-64-bit

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 15 Dec 2023 07:06:29 +0000

=== debian/control ===
--- 
+++ 
@@ -3,6 +3,7 @@
 Priority: optional
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
 Build-Depends: debhelper-compat  (= 13) , 
+ architecture-is-64-bit,
  ecbuild (>= 3.3.0-3),
  gfortran | fortran-compiler, 
  python3-all-dev,
@@ -14,8 +15,8 @@
  libemos-dev (>=  2:4.3.9),
  libeccodes-dev (>= 2.13.0-3),
  libeccodes-tools,
- libodc-dev [!powerpc !armel !armhf !hppa !i386 !mipsel],
- odc [!powerpc !armel !armhf !hppa !i386 !mipsel],
+ libodc-dev,
+ odc,
  libemos-bin, 
  libopenjp2-7-dev,
  libaec-dev,

=== debian/rules ===
--- 
+++ 
@@ -68,6 +68,7 @@
 	-DENABLE_TESTS=ON \
 	-DENABLE_GEOTIFF=ON \
 	-DGEOTIFF_INCLUDE_DIR=/usr/include/geotiff \
+	-DXKB_INCLUDE_DIR=/usr/include/xkb \
 	-DENABLE_RPATHS=OFF \
 	-DENABLE_CAIRO=ON \
 	-DENABLE_BUFR=ON \
@@ -75,7 +76,7 @@
 	-DENABLE_METVIEW=ON \
 	-DENABLE_NETCDF=ON \
 	-DCMAKE_C_FLAGS='$(CFLAGS) ' \
-	-DCMAKE_CXX_FLAGS='$(CXXFLAGS) -I/usr/include/terralib -I/usr/include/terralib/kernel -I/usr/include/geotiff' \
+	-DCMAKE_CXX_FLAGS='$(CXXFLAGS) -I/usr/include/terralib -I/usr/include/terralib/kernel -I/usr/include/geotiff -I/usr/include/xkb' \
 	-DMAGICS_EXTRA_LIBRARIES='-lterralib -lgd -lemosR64' 
 
 export LD_LIBRARY_PATH:=$(CURDIR)/debian/tmp/usr/lib:$(LD_LIBRARY_PATH)

## magics++ 4.15.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,8 @@
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")
 find_package( ecbuild 3.4 REQUIRED )
 
-project( magics VERSION 4.15.0 LANGUAGES CXX )
+
+project( magics VERSION 4.15.2 LANGUAGES CXX )
 
 # make sure that the header files are installed into include/magics
 # note that this needs to be done before ecbuild_declare_project()
@@ -25,7 +26,7 @@
 
 include(ecbuild_system NO_POLICY_SCOPE)
 
-set(CMAKE_CXX_STANDARD 14)
+set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_C_STANDARD 99)

=== debian/changelog ===
magics++ (4.15.2-1) unstable; urgency=medium

  * New upstream release
  * Use/recommend pkgconf rather than obsolete pkg-config

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 07 Feb 2024 07:06:50 +0000

magics++ (4.15.0-2) unstable; urgency=medium

  * Remove old 32-bit code from d/rules
  * Update reference to boost1.74->boost1.83
  * Build-depend on dh-fortran-mod for fortran-support.mk

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 01 Jan 2024 07:59:50 +0000

## magics++ 4.15.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,8 +15,7 @@
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")
 find_package( ecbuild 3.4 REQUIRED )
 
-
-project( magics VERSION 4.15.2 LANGUAGES CXX )
+project( magics VERSION 4.15.3 LANGUAGES CXX )
 
 # make sure that the header files are installed into include/magics
 # note that this needs to be done before ecbuild_declare_project()

=== tools/CMakeLists.txt ===
ecbuild_add_resources( TARGET tools_scripts
                       SOURCES 
                            magml2json.pl
                            mergexml.pl
                            newbase.pl
                            newclass.pl
                            newdriver.pl
                            newfactory.pl
                            newprojection.pl
                            newtemplate.pl
                            xml2cc.pl
                            xml2cc_list.pl
                            xml2doc.pl
                            xml2dtd.pl
                            xml2icon.pl
                            xml2mv.pl
                            magicsCompatibilityChecker
                      DONT_PACK
                            ParaTemplate.odt
)

install ( FILES magicsCompatibilityChecker   
            DESTINATION ${INSTALL_BIN_DIR} 
                        PERMISSIONS OWNER_READ GROUP_READ WORLD_READ 
                                                OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE)

=== apps/MagMLInterpretor/CMakeLists.txt ===
configure_file( magjson-script.in  magjson @ONLY )
configure_file( magml-script.in    magml   @ONLY )

install(FILES		${CMAKE_CURRENT_BINARY_DIR}/magjson
	DESTINATION	${INSTALL_BIN_DIR}
	PERMISSIONS	OWNER_READ GROUP_READ WORLD_READ
			OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE)

install(FILES		${CMAKE_CURRENT_BINARY_DIR}/magml
	DESTINATION	${INSTALL_BIN_DIR}
	PERMISSIONS	OWNER_READ GROUP_READ WORLD_READ
			OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE)

ecbuild_add_executable(
		TARGET		magjsonx
		SOURCES		json.cc
		DEFINITIONS	${MAGICS_EXTRA_DEFINITIONS}
		LIBS		MagPlus ${MAGICS_EXTRA_LIBRARIES}
		)


ecbuild_add_executable(
		TARGET		magics
		SOURCES		magics.cc
		DEFINITIONS	${MAGICS_EXTRA_DEFINITIONS}
		LIBS		MagPlus ${MAGICS_EXTRA_LIBRARIES}
		)

ecbuild_add_executable(
		TARGET		magmlx
                SOURCES		magml.cc
                DEFINITIONS	${MAGICS_EXTRA_DEFINITIONS}
		LIBS		MagPlus ${MAGICS_EXTRA_LIBRARIES}
		)

=== src/decoders/CMakeLists.txt ===
set( _decoders_srcs
BinningObject.cc
BinningObject.h
BoxPlotDecoder.cc
BoxPlotDecoder.h
Date.cc
MagDateTime.cc
MagDateTime.h
EfiLegendEntry.h
EpsXmlInput.cc
EpsXmlInput.h
GeoPointsDecoder.cc
GeoPointsDecoder.h
ImportAction.h
InputData.cc
InputData.h
InputMatrix.cc
InputMatrix.h
TileDecoder.h
TileDecoder.cc
InputMatrixInterpretor.cc
InputMatrixInterpretor.h
LandgramDecoder.cc
LandgramDecoder.h
LocalTable.cc
LocalTable.h
MapGenDecoder.cc
MapGenDecoder.h
MatrixTestDecoder.cc
MatrixTestDecoder.h
ObsStatDecoder.cc
ObsStatDecoder.h
ShapeDecoder.cc
ShapeDecoder.h
SimplePolylineInput.cc
SimplePolylineInput.h
SymbolInput.h
TableDecoder.cc
TableDecoder.h
ThinningMethod.cc
ThinningMethod.h
Time.cc
TitleField.cc
TitleField.h
TitleMetaField.cc
TitleMetaField.h
TitleStringField.cc
TitleStringField.h
TitleTemplate.cc
TitleTemplate.h
WindMode.cc
WindMode.h
XYList.cc
XYList.h
shapefil.h
shpopen.c
dbfopen.c
safileio.c
)

foreach( file ${_decoders_srcs} )
  list( APPEND decoders_srcs decoders/${file} )
endforeach()

if (HAVE_GRIB)
     list( APPEND decoders_srcs 
decoders/GribAddressMode.h
decoders/GribDecoder.cc
decoders/GribDecoder.h
decoders/GribInterpretor.h
decoders/GribLoopStep.cc
decoders/GribLoopStep.h
decoders/GribRegularInterpretor.cc
decoders/GribRegularInterpretor.h
decoders/GribSatelliteInterpretor.cc
decoders/GribSatelliteInterpretor.h
)
endif()


if (HAVE_NETCDF) 
     list( APPEND decoders_srcs 
#Netcdf--->
decoders/NetcdfOrcaInterpretor.cc
decoders/NetcdfData.cc
decoders/NetcdfData.h
decoders/NetcdfConvention.cc
decoders/NetcdfConvention.h
decoders/NetcdfDecoder.cc
decoders/NetcdfDecoder.h
decoders/NetcdfGeoMatrixInterpretor.cc
decoders/NetcdfGeoMatrixInterpretor.h
decoders/NetcdfGeopointsInterpretor.cc
decoders/NetcdfGeopointsInterpretor.h
decoders/NetcdfInterpretor.cc
decoders/NetcdfInterpretor.h
decoders/NetcdfMarsConvention.cc
decoders/NetcdfMarsConvention.h
decoders/NetcdfMatrixInterpretor.cc
decoders/NetcdfMatrixInterpretor.h
decoders/NetcdfOrcaInterpretor.h
decoders/NetcdfVectorInterpretor.cc
decoders/NetcdfVectorInterpretor.h
#<----Netcdf
)
endif()

if (HAVE_BUFR)
     list( APPEND decoders_srcs 
# Bufr --->
decoders/EpsBufr.cc
decoders/EpsBufr.h
decoders/ObsDecoder.cc
decoders/ObsDecoder.h
# <--- Bufr
)

endif()


if (HAVE_SPOT)
     list( APPEND decoders_srcs 
#Spot ---> 
decoders/ClassicMtgDecoder.cc
decoders/ClassicMtgDecoder.h
decoders/EpsgramDecoder.cc
decoders/EpsgramDecoder.h
#<--- Spot  
)
endif()

set( decoders_srcs ${decoders_srcs} PARENT_SCOPE )

if ( metview )
	list (APPEND metview_include 
			decoders/MagDateTime.h 
			decoders/GribDecoder.h 
			decoders/ThinningMethod.h 
			decoders/BinningObject.h  
			decoders/WindMode.h  
			decoders/GribAddressMode.h  
			decoders/GribLoopStep.h  
			decoders/GribInterpretor.h
			decoders/GribSatelliteInterpretor.h
			
			)
	set( metview_include ${metview_include} PARENT_SCOPE )
endif()

=== debian/changelog ===
magics++ (4.15.3-1build2) noble; urgency=medium

  * No-change rebuild against libqt6core6t64.

 -- Colin Watson <cjwatson@debian.org>  Mon, 15 Apr 2024 15:10:38 +0100

magics++ (4.15.3-1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 02:32:51 +0000

magics++ (4.15.3-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 02 Mar 2024 09:54:31 +0000

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,13 @@
 Source: magics++
 Section: science
 Priority: optional
-Maintainer: Alastair McKinstry <mckinstry@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Alastair McKinstry <mckinstry@debian.org>
 Build-Depends: debhelper-compat  (= 13) , 
  architecture-is-64-bit,
+ dh-fortran-mod (>= 0.31),
  ecbuild (>= 3.3.0-3),
- gfortran | fortran-compiler, 
+ pkgconf,
  python3-all-dev,
  libxcb-xkb-dev,
  libhdf5-dev | libhdf5-mpi-dev, 
@@ -27,7 +29,7 @@
  libxml-parser-perl, 
  ghostscript, 
  zlib1g-dev, 
- libboost-dev | libboost1.74-dev, 
+ libboost-dev | libboost1.83-dev, 
  qt6-base-dev,
  libqt6core5compat6-dev,
  libqt6svg6-dev,
@@ -68,7 +70,7 @@
  ${misc:Depends}, ${ecbuild:Depends},
  python3, libmagics++-metview-dev, libterralib-dev, magics++,
  libodc-dev [!powerpc !armel !armhf !hppa !i386 !mipsel]
-Recommends: pkg-config
+Recommends: pkgconf
 Description: Development files for ECMWF  plotting software MAGICS++
  Magics++ is the latest generation of the ECMWF's Meteorological plotting
  software MAGICS. Although completely redesigned in C++, it is intended to be

## magics++ 4.15.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")
 find_package( ecbuild 3.4 REQUIRED )
 
-project( magics VERSION 4.15.3 LANGUAGES CXX )
+project( magics VERSION 4.15.4 LANGUAGES CXX )
 
 # make sure that the header files are installed into include/magics
 # note that this needs to be done before ecbuild_declare_project()
@@ -55,6 +55,12 @@
                     DESCRIPTION "geotiff support [implies cairo] -  work on progress"
                     CONDITION HAVE_CAIRO
                     REQUIRED_PACKAGES GeoTIFF )
+
+ecbuild_add_option( FEATURE WEBP
+                    DEFAULT OFF
+                    DESCRIPTION "webp support [implies cairo]"
+                    CONDITION HAVE_CAIRO
+                    REQUIRED_PACKAGES WEBP )
 
 ecbuild_add_option( FEATURE NETCDF
                     DEFAULT ON
@@ -215,7 +221,16 @@
 
 else()
 
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wno-unused-parameter -Wno-overloaded-virtual -Wno-unused-variable -Wno-reorder -Wno-sign-compare")
+  # set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wno-unused-parameter -Wno-overloaded-virtual -Wno-unused-variable -Wno-reorder -Wno-sign-compare")
+  ecbuild_add_cxx_flags("-Wno-unused-parameter" NO_FAIL)
+  ecbuild_add_cxx_flags("-Wno-overloaded-virtual" NO_FAIL)
+  ecbuild_add_cxx_flags("-Wno-unused-variable" NO_FAIL)
+  ecbuild_add_cxx_flags("-Wno-reorder" NO_FAIL)
+  ecbuild_add_cxx_flags("-Wno-sign-compare" NO_FAIL)
+  # For NVIDIA
+  ecbuild_add_cxx_flags("--diag_suppress=partial_override" NO_FAIL)
+  ecbuild_add_cxx_flags("--diag_suppress=virtual_function_decl_hidden" NO_FAIL)
+  ecbuild_add_cxx_flags("--diag_suppress=code_is_unreachable" NO_FAIL)
 
   # set(CMAKE_CXX_FLAGS "-Wall -Wextra -Wno-unused-parameter -Wno-overloaded-virtual -Wno-unused-variable -Wno-reorder-ctor -Wno-sign-compare")
 
@@ -274,6 +289,12 @@
 	list( APPEND MAGICS_EXTRA_DEFINITIONS	HAVE_GEOTIFF )
 endif()
 
+if( HAVE_WEBP )
+	list( APPEND MAGICS_EXTRA_INCLUDE_DIRS	${WEBP_INCLUDE_DIR} )
+	list( APPEND MAGICS_EXTRA_LIBRARIES ${WEBP_LIBRARY} )
+	list( APPEND MAGICS_EXTRA_DEFINITIONS	HAVE_WEBP )
+endif()
+
 list( APPEND MAGICS_EXTRA_LIBRARIES     ${CMAKE_THREAD_LIBS_INIT} )
 
 if( EC_OS_NAME MATCHES "windows" )

=== debian/changelog ===
magics++ (4.15.4-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 19 Apr 2024 09:30:54 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: magics++
 Section: science
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Alastair McKinstry <mckinstry@debian.org>
+Maintainer: Alastair McKinstry <mckinstry@debian.org>
 Build-Depends: debhelper-compat  (= 13) , 
  architecture-is-64-bit,
  dh-fortran-mod (>= 0.31),

## magics++ 4.15.5

=== debian/changelog ===
magics++ (4.15.5-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 25 Nov 2024 10:21:43 +0000

magics++ (4.15.4-2) unstable; urgency=medium

  * Set Debian Science Maint. as maintainer
  * Standards-Version: 4.7.0; no changes required
  * g++14.patch to fix FTBFS on new compiler. Closes: #1075250

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 12 Jul 2024 12:28:42 +0100

## magics++ 4.16.0

=== debian/changelog ===
magics++ (4.16.0-1) unstable; urgency=medium

  * New upstream release
  * g++-14.patch: Update for incompatible-ptr check
  * Remove old FSF address;update d/copyright
  * Standards-Version: 4.7.2

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 14 Apr 2025 15:31:29 +0100
